﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

using WinWrap.Basic;
using WinWrap.Basic.Classic;

namespace SyncCrossThread
{
    public partial class Form1 : Form
    {
        // create a thread containing a BasicNoUIObj
        private BasicThread basic_thread_ = new BasicThread();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // get the IDE's synchronization context
            SynchronizationContext ui_sc = SynchronizationContext.Current;
            // send an action to the BasicThread
            basic_thread_.SendAction(basic =>
            {
                // configure basic
                basic.Synchronizing += (sender2, e2) =>
                {
                    // response/notification from the remote BasicNoUIObj
                    ui_sc.Post(state => {
                        // send response to the local BasicIdeCtl
                        basicIdeCtl1.Synchronize(e2.Param, 0);
                    }, null);
                };
                // set the BasicNoUIObj's secret
                basic.Secret = new Guid("00000000-0000-0000-0000-000000000000");
                // initialize basic in the remote thread
                basic.Initialize();
                // turn on NoUI's synchronized edit
                basic.SynchronizedEdit = true;
            });

            // turn on IDE's synchronized edit
            basicIdeCtl1.SynchronizedEdit = true;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (basic_thread_ != null)
            {
                if (basic_thread_.Kill())
                {
                    basic_thread_.Dispose();
                    basic_thread_ = null;
                }
                else
                    e.Cancel = true;
            }
        }

        private void basicIdeCtl1_Synchronizing(object sender, WinWrap.Basic.Classic.SynchronizingEventArgs e)
        {
            // send command to the BasicNoUIObj
            basic_thread_?.PostAction(basic => basic.Synchronize(e.Param, 0));
        }
    }
}
